clear, clc, mode(0), close(winsid()) 
/// Online odhad regresního modelu $y_t=b_0v_{1;t}+c_0v_{2;t}+a_1y_{t-1}+b_1v_{1;t-1}+c_1v_{2;t-1}+e_t$

load dataRychlost.sod;
y=rychlost; //// rychlost auta v koloně ve městě
v1=rychPred; //// rychlost vpředu jedoucího vozidla
v2=vzdal; //// vzdálenost mezi vozidly

nd=size(y,1);   /// počet dat


//////////////////////Odhadování 
nps=5+1;    //rozměr informační matice V
V=0.001*eye(nps,nps);    //počáteční informační matice V
k=0;                 //počáteční počítadlo k


/////////počáteční informační matice z apriorních dat
for t=2:50
    Ps=[y(t) v1(t) v2(t) y(t-1) v1(t-1) v2(t-1)];//rozšířený regresní vektor
    V=V+Ps'*Ps;        //update statistiky V 
end


theta_ulozit=[]; //pro uložení vývoje odhadu
for t=51:nd
    Ps=[y(t) v1(t) v2(t) y(t-1) v1(t-1) v2(t-1)];//rozšířený regresní vektor
    V=V+Ps'*Ps;        //update statistiky V 
    k=k+1;             //update statistiky k 

    //rozklad informační matice V
    Vy=V(1,1);        // část Vy 
    Vyps=V(2:$,1);   // část Vyps
    Vps=V(2:$,2:$);  //část Vps

    //bodové odhady
    theta_odhad=inv(Vps)*Vyps;      //bodové odhady regresních koeficientů
    r_odhad=(Vy-Vyps'*inv(Vps)*Vyps)/k; //bodový odhad rozptylu
    
    theta_ulozit=[theta_ulozit theta_odhad];      // uložíme odhad v čase
end


////výsledky
disp('Odhad regresních koeficientů',theta_odhad)
disp('Odhad rozptylu',r_odhad)

plot(theta_ulozit');
legend('$b_0$','$c_0$','$a_1$','$b_1$','$c_1$',-1);
title('Vývoj odhadu parametrů v čase','fontsize',5)
ylabel('Regresní koeficienty','fontsize',5)
xlabel('Čas','fontsize',5)




